cbuffer PackParamters
{
  int N_minus_1;
  float L_over_twoN;
};

struct Results
{
  float4 Position : SV_Target0;
  float4 Derivatives : SV_Target1;
};

Texture2D waveXY;
Texture2D waveZ;
Texture2D wavedZdu_dZdv;

Results main(float4 ScreenPos : SV_Position)
{
  int2 ij = int2(ScreenPos.xy);
  int2 ij_p = (ij + int2(1, 1)) & (int2)N_minus_1;
  int2 ij_m = (ij + int2(N_minus_1, N_minus_1)) & (int2)N_minus_1;

  Results r;
  r.Position = float4(waveXY.Load(int3(ij,0)).yw,
                      -waveZ.Load(int3(ij,0)).r,
                      0.f);

  //r.Derivatives = float4(L_over_twoN*(waveX.Load(int3(ij_p.x, ij.y, 0)).r - waveX.Load(int3(ij_m.x, ij.y, 0)).r),
  //                       L_over_twoN*(waveY.Load(int3(ij.x, ij_p.y, 0)).r - waveY.Load(int3(ij.x, ij_m.y, 0)).r),
  //                       L_over_twoN*(waveZ.Load(int3(ij_p.x, ij.y, 0)).r - waveZ.Load(int3(ij_m.x, ij.y, 0)).r),
  //                       L_over_twoN*(waveZ.Load(int3(ij.x, ij_p.y, 0)).r - waveZ.Load(int3(ij.x, ij_m.y, 0)).r));


  r.Derivatives = float4(L_over_twoN*(waveXY.Load(int3(ij_p.x, ij.y, 0)).y - waveXY.Load(int3(ij_m.x, ij.y, 0)).y),
                         L_over_twoN*(waveXY.Load(int3(ij.x, ij_p.y, 0)).w - waveXY.Load(int3(ij.x, ij_m.y, 0)).w),
                         wavedZdu_dZdv.Load(int3(ij, 0)).yw);

  return r;
}